%function FEM 
close all 
clear all
clc
format long
%!./triangle -aecpqA C.poly
%!./showme C.1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Inicializacion   
g=9.8; rho=1;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
fich=fopen('./CC2.1.node'); 
num=fscanf(fich,'%i',4); nverf=num(1);  
Coordinates=fscanf(fich,'%f',[4,nverf]);
fclose(fich);
Coordinates=Coordinates'; 
N_Sup=find(Coordinates(:,4)==2);
X_Sup=Coordinates(N_Sup,2);
Coordinates(:,4)=[]; Coordinates(:,1)=[];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fich=fopen('./CC2.1.ele'); 
num=fscanf(fich,'%i',3); nelf=num(1);
Elements=fscanf(fich,'%i',[5,nelf]);
fclose(fich);
Elements=Elements'; 
Elements(:,5)=[]; Elements(:,1)=[];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fich=fopen('./CC2.1.edge'); 
num=fscanf(fich,'%i',2); nladf=num(1); 
lados=fscanf(fich,'%f',[4,nladf]);
fclose(fich);
lados=lados';
Sup=find(lados(:,4)==2); %aristas de la sup. libre tienen etiqueta 3.
lados(:,4)=[]; lados(:,1)=[];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

K=sparse(nverf,nverf); M=sparse(nverf,nverf);

% Ensamble K
for j=1:size(Elements,1)
    K(Elements(j,:),Elements(j,:))=...
        K(Elements(j,:),Elements(j,:))...
	+STIMA3(Coordinates(Elements(j,:),:));
end

% Ensamble  M ?

	M=speye(nverf,nverf);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
p=4; % Numero de valores propios y funciones propias a calcular
[vp,lambda]=eigs(M,K+M,p,'LM');
fz=1./diag(lambda);
fz=sqrt(abs((fz-1)*g));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   

% Graficas superficie libre y presiones
[Y,IY]=sort(fz); Y
[XX,IX]=sort(X_Sup);
for z=2:p
    Y_Sup=vp(N_Sup,IY(z))/(g*rho);
    figure;
    plot(X_Sup(IX),Y_Sup(IX));
    figure
    SHOW(Elements,[],Coordinates,full(vp(:,IY(z))),Y(z));
    pause
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
